<?php

namespace app\models\mikrotik\system;

use yii\base\Model;
use Yii;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use PEAR2\Net\RouterOS;
use app\models\mikrotik\MikrotikConnect;

class Scripts extends Model {

    public $id;
    public $name;
    public $owner;
    public $policy;
    public $run_count;
    public $source;
    public $invalid;

    public function rules() {
        return [
            ['id', 'string'],
            ['name', 'string'],
            ['owner', 'string'],
            ['run_count', 'string'],
            ['source', 'string'],
            ['invalid', 'string'],
        ];
    }
    

    public function getAll() {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/system/script/getall');
        $responses = $connect->getConnection()->sendSync($getRequest);
        $return = array();
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $c = new Scripts();
                $c->id = $response->getProperty('.id');
                $c->name = $response->getProperty('name');
                $c->owner = $response->getProperty('owner');
                $c->policy = $response->getProperty('policy');
                $c->run_count = $response->getProperty('run-count');
                $c->source = $response->getProperty('source');
                $c->invalid = $response->getProperty('invalid');
                $return[] = $c;
            }
        }
        return $return;
    }

    public function get($id) {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/system/script/print');
        $getRequest->setQuery(RouterOS\Query::where('.id', $id));
        $responses = $connect->getConnection()->sendSync($getRequest);
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $this->id = $response->getProperty('.id');
                $this->name = $response->getProperty('name');
                $this->owner = $response->getProperty('owner');
                $this->policy = $response->getProperty('policy');
                $this->run_count = $response->getProperty('run-count');
                $this->source = $response->getProperty('source');
                $this->invalid = (($response->getProperty('invalid') == 'true') ? true : false);
            }
        }
        return;
    }

    public function update($id) {
        $c = new Scripts();
        $c->get($id);
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/system/script/set');
        $setRequest->setargument('.id', $id);
        if ($this->name != $c->name) {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->owner != $c->owner) {
            $setRequest->setargument('owner', $this->owner);
        }
        if ($this->policy != $c->policy) {
            $setRequest->setargument('policy', $this->policy);
        }
        if ($this->run_count != $c->run_count) {
            $setRequest->setargument('run-count', $this->run_count);
        }
        if ($this->source != $c->source) {
            $setRequest->setargument('source', $this->source);
        }
        if (isset($unset)) {
            $unsetRequest = new RouterOS\Request('/system/script/unset');
            foreach ($unset as $value) {
                $unsetRequest->setArgument('.id', $id);
                $unsetRequest->setArgument('value-name', $value);
                $resp = $connect->getConnection()->sendSync($unsetRequest);
                if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
                    if (!isset($re)) {
                        $re = '';
                    } $re.= ' ' . $resp->getProperty('message');
                }
            }
        } $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            if (isset($re)) {
                $re.= ' ' . $resp->getProperty('message');
            } else {
                $re = $resp->getProperty('message');
            }
        } if (isset($re)) {
            return $re;
        } else {
            return '1';
        }
    }

    public function run($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/system/script/run');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function create() {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/system/script/add');
        if ($this->name != "") {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->owner != "") {
            $setRequest->setargument('owner', $this->owner);
        }
        if ($this->policy != "") {
            $setRequest->setargument('policy', $this->policy);
        }
        if ($this->run_count != "") {
            $setRequest->setargument('run-count', $this->run_count);
        }
        if ($this->source != "") {
            $setRequest->setargument('source', $this->source);
        }
        $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            return $resp->getProperty('message');
        } else {
            return '1';
        }
    }

    public function delete($id) {
        $connect = MikrotikConnect::Instance();
        $util = new RouterOS\Util($connect->getConnection());
        $util->setMenu('/system/script');
        $util->remove(RouterOS\Query::where('.id', $id));
        return;
    }

}
